//==============================================================
// File: BSSnake.java																
// Created by O. Reshta (http://www.brigsoft.com), July 2001.	
// Copyright (c) 2001 O. Reshta. All Rights Reserved. 
//								
// O. Reshta grants you ("Licensee") a non-exclusive, royalty free, 
// license to use,  modify and redistribute this software in source 
// and binary code form, provided that 
// 1) this copyright notice and license appear on all copies of the software;
// 2) Licensee does not utilize the software in a manner which is disparaging to O. Reshta.
//
// This software is provided "AS IS," without a warranty of any kind. ALL
// EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
// IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
// NON-INFRINGEMENT, ARE HEREBY EXCLUDED. O.RESHTA SHALL NOT BE
// LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
// OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL O.RESHTA 
// BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
// INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
// CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
// OR INABILITY TO USE SOFTWARE, EVEN IF O.RESHTA HAS BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGES.
//
// This software is not designed or intended for use in on-line control of
// aircraft, air traffic, aircraft navigation or aircraft communications; or in
// the design, construction, operation or maintenance of any nuclear
// facility. Licensee represents and warrants that it will not use or
// redistribute the Software for such purposes.
//
//==============================================================//


import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.event.KeyListener;
import java.awt.event.MouseListener;
import java.net.MalformedURLException;
import java.net.URL;
import java.awt.image.*; 

public class BSJSnake extends Applet 
	implements KeyListener, MouseListener, Runnable
{
	class SnakeDead extends Exception{
		SnakeDead(){}
	}
	
	Thread timer;
	Image img;
	
	int gnRows	= 27;		// Number of game field rows.
	int gnCols	= 40;		// Number of game field columns.
	int gnCellSize = 15;	// Size of cell in pixels.	
	
	int m_nDeltaTime = 500;		// Game steps period (milliseconds).
	int m_nTicker = 0;			// Number of ticks from start of the game.

	
	boolean gbGameEnd = false;
		
	CCell gCell[][];
	
	CSnake m_Snake = new CSnake();
	CMouse m_Mouse = new CMouse();

	Rectangle gCopyrightRect = new Rectangle(405, 403, 195, 20);
	boolean gbInCopyright = false;
	Color gTextColor = new Color(0,0,155);
	
	Font fntBig;
	Font fntSmall;
	
	public void init()
	{
		addKeyListener(this);
		addMouseListener(this);
		
		fntBig = new Font("Arial", Font.BOLD, 20);
		fntSmall = new Font("Arial", Font.BOLD, 10);
		setFont(fntSmall);
			
		this.setBackground(new Color(255,255,255));
		this.setForeground(new Color(255,255,255));
		img = getImage(getCodeBase(),"BSJSnake.gif");

		gCell = new CCell[gnRows][];
		
		int i = 0;
		int j = 0;
		for(i = 0; i<gnRows; i++){
			gCell[i] = new CCell[gnCols];
			for(j=0;j<gnCols;j++){
				gCell[i][j] = new CCell();
			}
		}	
		
		try{
			m_Snake.Init();		
		}
		catch(SnakeDead d){
		}
		requestFocus();
		
	}

	void UpdateCell(int Row, int Col){
		Rectangle Rect = new Rectangle(Col*gnCellSize, Row*gnCellSize, (Col+1)*gnCellSize, (Row+1)*gnCellSize);
		repaint(Rect.x, Rect.y, Rect.width, Rect.height);
	}

	final int Space = 0;
	final int Head = 1;
	final int Tail = 2;
	final int Body = 3;
	final int BlueMouse  = 4;
	final int VioletMouse = 5;
	final int RedMouse = 6;
	final int Hedgehog =7;
	final int Non = 0;
	final int Rt = 1;
	final int Up = 2;
	final int Lf = 3;
	final int Dn = 4;

	public void paint(Graphics g){
		update(g);
	}
    public void update(Graphics g){
		
		if(gbGameEnd){
			g.fillRect(0,0,237, 62);
			g.setColor(gTextColor);
			g.setFont(fntBig);
			g.drawString("Game Over !!!" ,10,20);
			g.setFont(fntSmall);
			g.drawString("Len: " + m_Snake.m_nLen + "   Speed: " + 500/m_nDeltaTime ,10,40);
			g.drawString("Use Refresh button of your browser to restart." ,10,55);
			
			g.setColor(new Color(255,255,255));
			g.fillRect(400,390,600, 405);
			if(gbInCopyright){
				g.setColor(new Color(255,0,0));
			}
			else{
				g.setColor(gTextColor);
			}
			g.drawString("www.brigsoft.com, (C) O. Reshta, 2001",gCopyrightRect.x,gCopyrightRect.y);			
			g.drawLine(gCopyrightRect.x,gCopyrightRect.y+1, gCopyrightRect.x+90,gCopyrightRect.y+1);
		}
		else{
			for(int i = 0; i<gnRows; i++){
				for(int j=0;j<gnCols;j++){
					drawCell(g,i,j);
				}
			}
		}
		

	}
	
	public void drawCell(Graphics g,  int Row, int Col){
				
		Rectangle Rect = new Rectangle(Col*gnCellSize, Row*gnCellSize, (Col+1)*gnCellSize, (Row+1)*gnCellSize);
					
		switch (gCell[Row][Col].m_Type){
				
			case Space:
				g.fillRect(Rect.x , Rect.y, gnCellSize, gnCellSize);
			break;
				
		    case Head:
				switch(gCell[Row][Col].m_Dir){
					case Rt:
						g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
								6*gnCellSize,0,(6+1)*gnCellSize, gnCellSize,this);
					break;
					case Up:
						g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
								9*gnCellSize,0,(9+1)*gnCellSize, gnCellSize,this);
					break;
					case Lf:
						g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
								8*gnCellSize,0,(8+1)*gnCellSize, gnCellSize,this);
					break;
					case Dn:
						g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
								7*gnCellSize,0,(7+1)*gnCellSize, gnCellSize,this);
					break;
				}
			break;

			case Tail:
				switch(gCell[Row][Col].m_Dir){
					case Rt:
						g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
							0,0,gnCellSize, gnCellSize,this);
					break;
					case Up:
						g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
								1*gnCellSize,0,(1+1)*gnCellSize, gnCellSize,this);
					break;
					case Lf:
						g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
								2*gnCellSize,0,(2+1)*gnCellSize, gnCellSize,this);
					break;
					case Dn:
						g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
								3*gnCellSize,0,(3+1)*gnCellSize, gnCellSize,this);
					break;
				}		
			break;

			case Body:
				switch(gCell[Row][Col].m_Dir){
					case Rt:
					case Lf:
						g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
								5*gnCellSize,0,(5+1)*gnCellSize, gnCellSize,this);
					break;
					case Up:
					case Dn:
						g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
								4*gnCellSize,0,(4+1)*gnCellSize, gnCellSize,this);
					break;
				}
			break;

			case BlueMouse: 
					g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
							11*gnCellSize,0,(11+1)*gnCellSize, gnCellSize,this);
			break;
			case VioletMouse: 
					g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
							12*gnCellSize,0,(12+1)*gnCellSize, gnCellSize,this);
			break;
			case RedMouse:
					g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
							13*gnCellSize,0,(13+1)*gnCellSize, gnCellSize,this);
			break;
			case Hedgehog:
					g.drawImage(img,Rect.x,Rect.y,Rect.x+gnCellSize,Rect.y+gnCellSize,
							14*gnCellSize,0,(14+1)*gnCellSize, gnCellSize,this);
			break;
		}
		
		
	}//end draw
		
//-- Mouse --------------------------------------------//
	public void mousePressed(MouseEvent e){
	}
	public void mouseReleased(MouseEvent e){
	}
	public void mouseEntered(MouseEvent e){
	}
	public void mouseExited(MouseEvent e){
	}
	public void mouseClicked(MouseEvent e){
		if(gbGameEnd){
			gbInCopyright = true;
			repaint();
			AppletContext ac = getAppletContext();
			try{
				ac.showDocument( new URL("http://www.brigsoft.com"), "_blank");			
				stop();
			}
			catch(MalformedURLException eu){
				showStatus("Url not found");
			}
		}
	}
	
//-- Keyboard --------------------------------------------//
	public void keyPressed(KeyEvent ke){
		int key = ke.getKeyCode();
		switch(key){
			case KeyEvent.VK_LEFT:
				m_Snake.TurnLeft();
			break;
			case KeyEvent.VK_RIGHT:
				m_Snake.TurnRight();
			break;
			case KeyEvent.VK_SPACE:
			    // spead up.
				if(m_nDeltaTime>10){
					m_nDeltaTime/=1.5;
				}
			break;
		}
	}
	public void keyReleased(KeyEvent ke){
	}
	public void keyTyped(KeyEvent ke){
	}

//- Timer ------------------------------------------
    public void start() {
        timer = new Thread(this);
        timer.start();
    }

    public void stop() {
        timer = null;
    }

    public void run() {
		
        Thread me = Thread.currentThread();
        while (timer == me) {
            try {
				Thread.currentThread().sleep(m_nDeltaTime);				
				// Speed up solution.				
            } catch (InterruptedException e) {
            }

			// Move snake.
			try{
				// Swallow a mouse  ore a hedgehog if it is in the front cell.
				m_nTicker++;

				if(m_nDeltaTime >250){
					m_nDeltaTime -=25;
				}
				else{
					if( m_nTicker%5 ==0 ){
						if(m_nDeltaTime >100){
							m_nDeltaTime --;
						}
					}
				}
					
				m_Mouse.Generate();
				m_Snake.TestFront();

				// Grow one unit if snake must grow.
				if(m_Snake.m_nGrowLen > 0){
					m_Snake.Grow();
					-- m_Snake.m_nGrowLen;
					++ m_Snake.m_nLen;
				}
				// Move snake if it must not grow.
				else{
					m_Snake.Move();
				}
			}

			// Horrible death;-)
			catch(SnakeDead d){
				gbGameEnd=true;
				repaint();
				break;
			}
        }// end while
    }// end Run
	
	//---------------------------------------------------
	// Game classes
	//---------------------------------------------------
		
	// - CCell -------------------------------------------
	// A cell of game field.
	// It stores snake units, mice, hedgehogs, moving directions
	// and draws items.	
	

	class CCell
	{
		int		m_Type = 0;
		int		m_Dir = 1;
		
		void TurnLeft(){
			switch (m_Dir){
				case 1://Rt:
					m_Dir = 2;//Up;
				break;
				case 2://Up:
					m_Dir = 3;//Lf;
				break;
				case 3://Lf:
					m_Dir = 4;//Dn;
				break;
				case 4://Dn:
					m_Dir = 1;//Rt;
				break;
			}
		}
		
		void TurnRight(){
			switch (m_Dir){
				case 1://Rt:
					m_Dir = 4;//Dn;
				break;
				case 4://Dn:
					m_Dir = 3;//Lf;
				break;
				case 3://Lf:
					m_Dir = 2;//Up;
				break;
				case 2://Up:
					m_Dir = 1;//Rt;
				break;
			}
		}


	}
	
	class  CPnt
	{
		int row;
		int col;
		
		CPnt(){
			row = 0;
			col = 0;
		}

		CPnt(CPnt pnt){
			row = pnt.row;
			col = pnt.col;
		}
		
		void MoveToDir(int Dir) throws SnakeDead {
			switch(Dir){
				case 1://Rt:
					col++;
					if(col >= gnCols){
						throw new SnakeDead();
					}
				break;
				case 2://Up:
					row--;
					if(row <0){
						throw new SnakeDead();
					}
				break;
				case 3://Lf:
					col--;
					if(col < 0){
						throw new SnakeDead();
					}
				break;
				case 4://Dn:
					row++;
					if(row >= gnRows){
						throw new SnakeDead();
					}
				break;
			}
		}
	}
	
	class CSnake{
		CPnt		m_Head = new CPnt();
		CPnt		m_Tail = new CPnt();
		int			m_nGrowLen;
		int			m_nLen;
		
		void Init()throws SnakeDead
		{
			// To clear the game field.
			for(int i = 0; i<gnRows; i++){
				for(int j=0;j<gnCols;j++){
					gCell[i][j].m_Type = 0;
					gCell[i][j].m_Dir = 0;
				}
			}

			// To init snake : set head and tail, then make little growing.
			m_Head.row = 3*gnRows/4;
			m_Head.col = gnCols/2;
			m_Tail.row = m_Head.row + 1;
			m_Tail.col = m_Head.col;

			m_nGrowLen = 0;
			m_nLen = 5;

			gCell[m_Head.row][m_Head.col].m_Type = 1;//SetType(CCell::Head);
			gCell[m_Head.row][m_Head.col].m_Dir = 2; //.SetDir(Up);
			gCell[m_Tail.row][m_Tail.col].m_Type = 2;//.SetType(CCell::Tail);
			gCell[m_Tail.row][m_Tail.col].m_Dir = 2;//.SetDir(Up);

			for(int i =0; i<3;i++){
				Grow();
			}
			
		}// end Init

		void TestFront() throws SnakeDead {
					
			CPnt TestPnt = new CPnt(m_Head);
			TestPnt.MoveToDir(gCell[m_Head.row][m_Head.col].m_Dir);

			if(gCell[TestPnt.row][TestPnt.col].m_Type == 0){ //CCell::Space
				return;
			}

			// Yahoo!!! Snake is growing.

			switch(gCell[TestPnt.row][TestPnt.col].m_Type){
				case 4://CCell::BlueMouse: 
					m_nGrowLen+=3;
				break;
				case 5://CCell::VioletMouse: 
					m_nGrowLen+=5;
				break;
				case 6://CCell::RedMouse:
					m_nGrowLen+=9;
				break;
				case 7://CCell::Hedgehog:
					throw new SnakeDead();
				default:
					throw new SnakeDead();
			}

		}// end TestFront
		
		void Grow()throws SnakeDead{
			
			gCell[m_Head.row][m_Head.col].m_Type = 3;//SetType(CCell::Body);
			UpdateCell(m_Head.row,m_Head.col);

			int OldDir = gCell[m_Head.row][m_Head.col].m_Dir;

			m_Head.MoveToDir(OldDir);

			gCell[m_Head.row][m_Head.col].m_Type = 1;//.SetType(CCell::Head);
			gCell[m_Head.row][m_Head.col].m_Dir = OldDir;//.SetDir(OldDir);
			UpdateCell(m_Head.row,m_Head.col);

		}
		
		void Move()throws SnakeDead
		{
			// Move head.
			Grow();

			// Move tail.
			
			int OldDir = gCell[m_Tail.row][m_Tail.col].m_Dir;
			
			gCell[m_Tail.row][m_Tail.col].m_Dir = 0;//SetDir(Non);
			gCell[m_Tail.row][m_Tail.col].m_Type = 0;//SetType(CCell::Space);
			UpdateCell(m_Tail.row,m_Tail.col);
			
			m_Tail.MoveToDir(OldDir);
			gCell[m_Tail.row][m_Tail.col].m_Type = 2;//SetType(CCell::Tail);

			UpdateCell(m_Tail.row,m_Tail.col);
		}
		
	
		void TurnLeft()	{
				gCell[m_Head.row][m_Head.col].TurnLeft();
			    UpdateCell(m_Head.row,m_Head.col);
		}
		void TurnRight(){
				gCell[m_Head.row][m_Head.col].TurnRight();
			    UpdateCell(m_Head.row,m_Head.col);
		}
	}
// ---------------------------------------------------	
	class CMouse
	{
		int m_nTicker;
		CMouse(){
			m_nTicker = -1;
		}
		
		void Generate()
		{
			m_nTicker ++;

			if(m_nTicker % 10 != 0){
				return;
			}
				
			int nRow = (int)(Math.random()*(gnRows-1));
			int nCol = (int)(Math.random()*(gnCols-1));

			if(gCell[nRow][nCol].m_Type == 0){

				int nMouse = (int)(Math.random()*5);
				switch(nMouse){
					case 1:
						gCell[nRow][nCol].m_Type =4;//.SetType(CCell::BlueMouse);
					break;
					case 2:
						gCell[nRow][nCol].m_Type =5;//.SetType(CCell::VioletMouse);
					break;
					case 3:
						gCell[nRow][nCol].m_Type =6;//;.SetType(CCell::RedMouse);
					break;
					default:
						if(!(m_nTicker % 100 != 0)){
							gCell[nRow][nCol].m_Type =7;//.SetType(CCell::Hedgehog);
						}
					break;
				}

			    UpdateCell(nRow,nCol);
			}
		}
	}

}